/*
 * Copyright (c) 2020 PHYTEC Messtechnik GmbH, Peter Johanson
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#ifndef ZEPHYR_DRIVERS_DISPLAY_IL0323_REGS_H_
#define ZEPHYR_DRIVERS_DISPLAY_IL0323_REGS_H_

#define IL0323_CMD_PSR				0x00
#define IL0323_CMD_PWR				0x01
#define IL0323_CMD_POF				0x02
#define IL0323_CMD_PFS				0x03
#define IL0323_CMD_PON				0x04
#define IL0323_CMD_PMES				0x05
#define IL0323_CMD_CPSET			0x06
#define IL0323_CMD_DSLP				0x07
#define IL0323_CMD_DTM1				0x10
#define IL0323_CMD_DSP				0x11
#define IL0323_CMD_DRF				0x12
#define IL0323_CMD_DTM2				0x13
#define IL0323_CMD_AUTO				0x17
#define IL0323_CMD_LUTOPT			0x2A
#define IL0323_CMD_PLL				0x30
#define IL0323_CMD_TSC				0x40
#define IL0323_CMD_TSE				0x41
#define IL0323_CMD_PBC				0x44
#define IL0323_CMD_CDI				0x50
#define IL0323_CMD_LPD				0x51
#define IL0323_CMD_TCON				0x60
#define IL0323_CMD_TRES				0x61
#define IL0323_CMD_GSST				0x65
#define IL0323_CMD_REV				0x70
#define IL0323_CMD_FLG				0x71
#define IL0323_CMD_CRC				0x72
#define IL0323_CMD_AMV				0x80
#define IL0323_CMD_VV				0x81
#define IL0323_CMD_VDCS				0x82
#define IL0323_CMD_PTL				0x90
#define IL0323_CMD_PIN				0x91
#define IL0323_CMD_POUT				0x92
#define IL0323_CMD_PGM				0xA0
#define IL0323_CMD_APG				0xA1
#define IL0323_CMD_ROTP				0xA2
#define IL0323_CMD_CCSET			0xE0
#define IL0323_CMD_PWS				0xE3
#define IL0323_CMD_LVSEL			0xE4
#define IL0323_CMD_TSSET			0xE5

#define IL0323_PSR_RES_WIDTH			BIT(7)
#define IL0323_PSR_RES_HEIGHT			BIT(6)
#define IL0323_PSR_LUT_REG			BIT(5)
#define IL0323_PSR_LUT_OTP			BIT(4)
#define IL0323_PSR_UD				BIT(3)
#define IL0323_PSR_SHL				BIT(2)
#define IL0323_PSR_SHD				BIT(1)
#define IL0323_PSR_RST				BIT(0)

#define IL0323_AUTO_PON_DRF_POF			0xA5
#define IL0323_AUTO_PON_DRF_POF_DSLP		0xA7

#define IL0323_CDI_REG_LENGTH			1U
#define IL0323_CDI_CDI_IDX			0

#define IL0323_TRES_REG_LENGTH			2U
#define IL0323_TRES_HRES_IDX			0
#define IL0323_TRES_VRES_IDX			1

#define IL0323_PTL_REG_LENGTH			5U
#define IL0323_PTL_HRST_IDX			0
#define IL0323_PTL_HRED_IDX			1
#define IL0323_PTL_VRST_IDX			2
#define IL0323_PTL_VRED_IDX			3
#define IL0323_PTL_PT_SCAN			BIT(0)

/* Time constants in ms */
#define IL0323_RESET_DELAY			10U
#define IL0323_PON_DELAY			100U
#define IL0323_BUSY_DELAY			1U

#endif /* ZEPHYR_DRIVERS_DISPLAY_IL0323_REGS_H_ */